using Infragistics.Win.UltraWinGrid;
using System.Windows.Forms;
using System;



public class UltraGridUddMouseWheelHack
{
    private object mUddSavedValueForMouseWheelHack;
    public UltraGrid mUgrid;

    public void InigUltraGridUddMouseWheelHack()
    {
        this.mUgrid.ControlAdded += new ControlEventHandler(this.mUGrid_ControlAdded);
    }

    private void mUGrid_ControlAdded(object sender, ControlEventArgs e)
    {
        UltraGrid uGrid = (UltraGrid) sender;
        UltraDropDown udd = uGrid.ActiveCell.ValueListResolved as UltraDropDown;
        if (udd != null)
        {
            e.Control.MouseWheel += new MouseEventHandler(this.mUGrid_uddControl_MouseWheel);
            e.Control.KeyUp += new KeyEventHandler(this.mUGrid_uddControl_KeyUp);
            e.Control.Enter += new EventHandler(this.mUGrid_uddControl_Enter);
            udd.AfterCloseUp += new DropDownEventHandler(this.mUGrid_uddControl_AfterCloseUp);
        }
    }

    private void mUGrid_uddControl_AfterCloseUp(object sender, DropDownEventArgs e)
    {
        this.SaveUltraDropDownSelectedValue();
    }

    private void mUGrid_uddControl_Enter(object sender, EventArgs e)
    {
        Control senderControl = (Control) sender;
        UltraGrid uGrid = senderControl.Parent as UltraGrid;
        if (uGrid != null)
        {
            UltraDropDown dropdown = uGrid.ActiveCell.ValueListResolved as UltraDropDown;
            if (dropdown != null)
            {
                this.mUddSavedValueForMouseWheelHack = uGrid.ActiveCell.Value;
            }
        }
    }

    private void mUGrid_uddControl_KeyUp(object sender, KeyEventArgs e)
    {
        this.SaveUltraDropDownSelectedValue();
    }

    private void mUGrid_uddControl_MouseWheel(object sender, MouseEventArgs e)
    {
        Control conSender = (Control) sender;
        UltraGrid ugSender = (UltraGrid) conSender.Parent;
        if (ugSender != null)
        {
            UltraDropDown dropdown = ugSender.ActiveCell.ValueListResolved as UltraDropDown;
            if ((dropdown != null) && (!dropdown.IsDroppedDown))
            {
                ugSender.ActiveCell.Value = this.mUddSavedValueForMouseWheelHack;
                ugSender.PerformAction(UltraGridAction.ExitEditMode, false, false);
            }
        }
    }

    private void SaveUltraDropDownSelectedValue()
    {
        if ((this.mUgrid.ActiveCell != null) && (this.mUgrid.ActiveCell.ValueListResolved != null))
        {
            this.mUddSavedValueForMouseWheelHack = this.mUgrid.ActiveCell.ValueListResolved.GetValue(this.mUgrid.ActiveCell.ValueListResolved.SelectedItemIndex);
        }
    }
}
